---
- pip:
    executable: pip3
    name: ["hvac==0.10.11", "hvac[parser]"]

- name: Set hook url
  set_fact:
    hook_url: "{{ ocp_host }}/apis/build.openshift.io/v1/namespaces/{{ ocp_ns }}/buildconfigs/dover/webhooks/{{ gitlab_key }}/gitlab"

- name: Get webhooks list
  uri:
    url: "https://gitlab.com/api/v4/projects/{{ project_id }}/hooks"
    method: GET
    return_content: yes
    headers:
      Authorization: "Bearer {{ gitlab_token }}"
  register: results

- name: Project hook id
  set_fact:
    hook_id: "{{ item.id }}"
  loop: "{{ results.json | list }}"
  when: item.url == hook_url

- name: Update project hook
  uri:
    url: "https://gitlab.com/api/v4/projects/{{ project_id }}/hooks/{{ hook_id }}"
    method: PUT
    return_content: yes
    headers:
      Authorization: "Bearer {{ gitlab_token }}"
    body_format: json
    body:
      id: "{{ project_id }}"
      push_events_branch_filter: "{{ branch }}"
      push_events: true
      url: "{{ hook_url }}"
    status_code: 200
  register: result
  when: hook_id is defined

- name: Create project hook
  uri:
    url: "https://gitlab.com/api/v4/projects/{{ project_id }}/hooks"
    method: POST
    return_content: yes
    headers:
      Authorization: "Bearer {{ gitlab_token }}"
    body_format: json
    body:
      id: "{{ project_id }}"
      push_events_branch_filter: "{{ branch }}"
      push_events: true
      url: "{{ hook_url }}"
    status_code: 201
  register: result
  when: hook_id is not defined
